<?php
# 2005 jul 31

#drop table if exists loginpermission;
#create table loginpermission
#(
#  id int primary key not null auto_increment,
#  lastinsert datetime default "0000-00-00 00:00:00",
#  lastupdate datetime default "0000-00-00 00:00:00",
#  username varchar(64) not null,
#  permission varchar(64) not null,
#  unique key userpermkey (username, permission)
#);

include_once("usermenu.inc");

class itemadmin extends usermenu
{
  function itemadmin
  (
  )
  {
    usermenu::usermenu();

    $this->label["searchobjname"] = "Item name";
    $this->label["search"] = "Search";
    $this->label["new"] = "New";
    $this->label["modify"] = "Modify";
    $this->label["remove"] = "Remove";
    $this->label["removalconfirmation"] = "Confirm removal of the following?";
    $this->label["save"] = "Save";
    $this->label["responsemessage"] = "";
    $this->label["removalerror"] = "Cannot remove user.";
    $this->label["processcompleted"] = "Process completed.";
    $this->label["objname"] = "Item name";
    $this->label["objnameerror"] = "Item name error.";
    $this->label["unitprice"] = "Unit Price";

    return;
  }

  function gethiddentags
  (
  )
  {
    $str = "";
    $str .= sprintf("%s", usermenu::gethiddentags());
    $hiddenarray =
      array
      (
        "objfuncconfirm" => sprintf("%s", ""),
      );
    reset($hiddenarray);
    while(list($hiddenkey,$hiddenvalue) = each($hiddenarray))
    {
      $str .= <<<_STR_
<input type="hidden" name="${hiddenkey}" value="${hiddenvalue}">
_STR_;
    }
    return $str;
  }

  function getpaneltags
  (
  )
  {
    $searchtags = sprintf("%s", $this->getsearchtags());
    $navigationtags = sprintf("%s", $this->getnavigationtags());
    $controltags = sprintf("%s", $this->getcontroltags());
    $labelobj = sprintf("%s", $this->label["".get_class($this)]);
    $str = "";
    $str .= <<<_STR_
<table width="800" cellspacing="0" cellpadding="0" border="1">
<tr>
<td valign="top" colspan="2">
<center>
<b>[ ${labelobj} ]</b>
<br><br>
${searchtags}
</center>
</td>
</tr>
<tr>
<td valign="top" width="1%">
${navigationtags}
&nbsp;
</td>
<td valign="top">
${controltags}
&nbsp;
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getobjfunctags
  (
  )
  {
    $obj = get_class($this);
    $menuarray =
      array
      (
        "new" => "",
        "modify" => "",
        "remove" => "",
      );
    $str = "";
    $str .= <<<_STR_
<table width="100%" cellspacing="0" cellpadding="0" bgcolor="#ffffff">
<tr>
<td valign="top">
<div align="right">
_STR_;
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      $str .= <<<_STR_
&nbsp;<a href="javascript:setobjfunc('${obj}','${menukey}');">${label}</a> |
_STR_;
    }
    $str .= <<<_STR_
</div>
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getsearchtags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);
    $menuarray =
      array
      (
        "searchobjname" => sprintf("%s", $searchobjname),
      );
    $str = "";
    $str .= <<<_STR_
<table cellspacing="0" cellpadding="0" bgcolor="#ffffff">
<tr>
_STR_;
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      $str .= <<<_STR_
<td valign="top"><b>${label} :&nbsp;</b></td>
<td valign="top"><input type="text" name="${menukey}" value="${menuvalue}"></td>
_STR_;
    }
    $str .= <<<_STR_
<td valign="top">&nbsp;</td>
<td valign="top"><input class="globalbutton" type="button" onclick="javascript:setobjfunc('${obj}','');" value="${labelsearch}"></td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getnavigationtags
  (
  )
  {
    extract($this->vars);
    $obj = get_class($this);
    $objname = "itemname";

    $condition = "";
    if ($searchobjname != "")
    {
      $condition = sprintf(" where %s like \"%s%%\" ",
        $objname,
        $searchobjname);
    }
    $sql = sprintf("select * from itemlist %s order by %s;",
      $condition,
      $objname);
    $db = new dbmysql();
    $db->setquery($sql);
    reset($db->result);
    while(list($dbkey,$dbvalue) = each($db->result))
    {
      $dbarray["$dbkey"] = $dbvalue["itemlist.".${objname}];
    }
    $dbarray[""] = "";

#    asort($dbarray);
    natcasesort($dbarray);

    reset($dbarray);
    while(list($dbkey,$dbvalue) = each($dbarray))
    {
      $selected = "";
      if ($dbvalue == $objid)
      {
        $selected = "selected";
      }
      $optiontags .= sprintf("<option value=\"%s\" %s>%s</option>\n",
        $dbvalue,
        $selected,
        $dbvalue);
    }

    $str = "";
    $str .= <<<_STR_
<script>
var objlistarray=new Array();
function setobjid
(
  objid
)
{
  setobjfunc('${obj}', '');
  return;
}
</script>
<div id="dividobjlist">
<select style="width:150px;" name="objid" onchange="javascript:setobjid(this.value);">
${optiontags}
</select>
</div>
_STR_;
    return $str;
  }

  function getcontroltags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $obj = get_class($this);
    $responsemessage = $this->responsemessage;

    $str = "";
    $str .= <<<_STR_
<script>
var objid='';
</script>
<table width="100%" bgcolor="#99ccff">
<tr>
<td valign="top">
<div align="right">
_STR_;
    $menuarray =
      array
      (
        "new" => sprintf("%s", $labelnew),
        "modify" => sprintf("%s", $labelmodify),
        "remove" => sprintf("%s", $labelremove),
      );
    $labelobjfunc = sprintf("[ %s ]", $labelmodify);
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      if ($menukey == $objfunc)
      {
        $labelobjfunc = sprintf("[ %s ]", $menuvalue);
      }
      $str .= <<<_STR_
[ <a class="globallink" href="javascript:setobjfunc('${obj}','${menukey}');">${menuvalue}</a> ]&nbsp;
_STR_;
    }
    $str .= <<<_STR_
</div>
</td>
</tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#ffffff"><tr><td valign="top"><center>&nbsp;${responsemessage}</center></td></tr></table>
<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#ffffff"><tr><td valign="top"><b>&nbsp;${labelobjfunc}</b></td></tr></table>
_STR_;
    if (($objfunc == "") &&
        ($objid != ""))
    {
      $objfunc = "modify";
    }
    if ($objfunc == "new")
    {
      $str .= $this->getobjfuncnewtags();
    }
    if ($objfunc == "modify")
    {
      $str .= $this->getobjfuncmodifytags();
    }
    if ($objfunc == "remove")
    {
      $str .= $this->getobjfuncremovetags();
    }
    return $str;
  }

  function getobjfuncnewtags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));

    $objname = "itemname";

    $str = <<<_STR_
<script>
function setnew
(
)
{
  if (document.forms[0].${objname}.value == '')
  {
    alert('${labelobjnameerror}');
    return;
  }
  document.forms[0].objfuncconfirm.value='true';
  setobjfunc('${obj}','${objfunc}');
  return;
}
</script>
<table>
<tr>
<td valign="top"><b>${labelobjname} :&nbsp;</b></td>
<td valign="top"><input type="text" name="itemname"></td>
</tr>
<tr>
<td valign="top">&nbsp;</td>
<td valign="top"><input type="button" class="globalbutton" onclick="javascript:setnew();" value=" ${labelsave} "></td>
</tr>
</table>
_STR_;

    return $str;
  }

  function getobjfuncmodifytags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    $objfunc = "modify";
    $str .= <<<_STR_
<table>
_STR_;
    $sql = sprintf("select * from itemlist where itemname=\"%s\";",
      mysql_escape_string($objid));
    $db = new dbmysql();
    $db->setquery($sql);
    $fieldarray =
      array
      (
        "unitprice" => sprintf("%s", $db->result[0]["itemlist.unitprice"]),
      );
    reset($fieldarray);
    while(list($fieldkey,$fieldvalue) = each($fieldarray))
    {
      $label=$this->label["${fieldkey}"];
      $fieldtype = "text";
      $inputtag = sprintf("<input type=\"%s\" name=\"%s\" value=\"\">\n",
        $fieldtype,
        $fieldkey);
      if ($fieldkey == "unitprice")
      {
        $fieldtype = "text";
        $inputtag = sprintf("<input type=\"%s\" maxlength=\"16\" size=\"16\" name=\"%s\" value=\"%0.2f\">\n",
          $fieldtype,
          $fieldkey,
          $fieldvalue);
      }
      $str .= <<<_STR_
<tr>
<td valign="top"><b>${label} :&nbsp;</b></td>
<td valign="top">${inputtag}</td>
</tr>
_STR_;
    }

    $str .= <<<_STR_
</td>
</tr>
<tr>
<td valign="top">&nbsp;</td>
<td valign="top"><input type="button" class="globalbutton" onclick="javascript:setmodify();" value=" ${labelsave} "></td>
</tr>
_STR_;

    $str .= <<<_STR_
</table>
<script>
function setmodify
(
)
{
  document.forms[0].objfuncconfirm.value = 'true';
  setobjfunc('${obj}','${objfunc}');
  return;
}
</script>
<input type="hidden" name="itemname" value="${objid}">
_STR_;
    return $str;
  }

  function getobjfuncremovetags
  (
  )
  {
    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));
    if ($objid == $this->masteradmin)
    {
      $str .= <<<_STR_
${labelremovalerror}
_STR_;
    }
    if ($objid != $this->masteradmin)
    {
      if (($objid != "") &&
          ($this->vars["objfuncconfirm"] != "true"))
      {
        $str .= <<<_STR_
<center>
${labelremovalconfirmation}
<br><br>
<b>${objid}</b>
<br><br>
<input type="hidden" name="itemname" value="${objid}">
<input type="button" class="globalbutton" onclick="javascript:document.forms[0].objfuncconfirm.value='true';setobjfunc('${obj}','${objfunc}');" value=" ${labelremove} ">
</center>
_STR_;
      }
    }
    return $str;
  }

  function settransaction
  (
  )
  {
    usermenu::settransaction();

    extract($this->vars);
    extract($this->commontool->getprefixkeyarray($this->label, "label", "add"));

    if ($itemname == "")
    {
      return;
    }
    if ($objfuncconfirm != "true")
    {
      return;
    }
    $datetimenow = date("Y-m-d H:i:s");
    $this->responsemessage = $labelprocesscompleted;

    if ($objfunc == "new")
    {
      $sql = sprintf("select count(id) from itemlist;");
      $db=new dbmysql();
      $db->setquery($sql);
      $countid = sizeof($db->result);

      $sql = sprintf("select max(id) from itemlist;");
      $db=new dbmysql();
      $db->setquery($sql);
      $maxid = sprintf("%d", $db->result[0][".max(id)"]) + 1;
      if ($countid <= 0)
      {
        $maxid = 1;
      }

      unset($recordarray);
      $fields = $this->commontool->getdbtablefields("itemlist");
      reset($fields);
      while(list($fieldkey,$fieldvalue) = each($fields))
      {
        $recordarray[sprintf("%s", $fieldkey)] = sprintf("\"\"");
      }
      $recordarray["id"] = sprintf("\"%s\"", mysql_escape_string($maxid));
      $recordarray["id"] = sprintf("null", mysql_escape_string($maxid));
      $recordarray["lastinsert"] = sprintf("\"%s\"", mysql_escape_string($datetimenow));
      $recordarray["lastupdate"] = sprintf("\"%s\"", mysql_escape_string($datetimenow));
      $recordarray["usernameinsert"] = sprintf("\"%s\"", mysql_escape_string($loginusername));
      $recordarray["usernameupdate"] = sprintf("\"%s\"", mysql_escape_string($loginusername));
      $recordarray["itemname"] = sprintf("\"%s\"", mysql_escape_string($itemname));

      $sql = sprintf("insert into itemlist (%s) values (%s);",
        implode(",", array_keys($recordarray)),
        implode(",", array_values($recordarray)));
      $db=new dbmysql();
      $db->setquery($sql);
      $this->vars["objid"] = $itemname;
      $this->vars["objfunc"] = "modify";
      return;
    }
    if ($objfunc == "modify")
    {
      unset($recordarray);
      $recordarray =
        array
        (
          "lastupdate" => sprintf("lastupdate=\"%s\"", $datetimenow),
          "unitprice" => sprintf("unitprice=\"%0.2f\"", $unitprice),
        );
      $sql = sprintf("update itemlist set %s where itemname=\"%s\";",
        implode(",", $recordarray),
        $itemname);
      $db=new dbmysql();
      $db->setquery($sql);
      return;
    }
    if ($this->vars["objfunc"] == "remove")
    {
      $sql = sprintf("delete from itemlist where itemname=\"%s\";",
        mysql_escape_string($itemname));
      $db=new dbmysql();
      $db->setquery($sql);
      return;
    }

    return;
  }
}
?>
